/*
  This code will run the robot-car using the bluetooth module
*/
//--------------------------Bluetooth Module----------------------
#include <SoftwareSerial.h> //Include the Serial Library

SoftwareSerial mySerial(12, 2); // TX, RX  Replace "pin" with the digital pin you plan to connect to.
//-----------------------end Bluetooth Module---------------------

//---------------------------Motor--------------------------------
// Left Motor
#define ENA   6
#define IN1   10
#define IN2   11

// Right Motor
#define ENB   5
#define IN3   9
#define IN4   8
//------------------------end Motor-------------------------------

//no Delay variable
long int preMillis[10];
bool delayBuffer[10];

void setup() {
  //-------------------Motor setup--------------------------
  // Set all the motor control pins to outputs
  pinMode(ENA, OUTPUT);
  pinMode(ENB, OUTPUT);
  pinMode(IN1, OUTPUT);
  pinMode(IN2, OUTPUT);
  pinMode(IN3, OUTPUT);
  pinMode(IN4, OUTPUT);
  //----------------Motor setup end-------------------------
  
  Serial.begin(38400); // Fill in the empty parenthesis with a baud rate.
  Serial.println("Testing Robot Car Bluetooth Module and Joystick App");
  mySerial.begin(38400); // Fill in the empty parenthesis with a baud rate.
  //Speed(.5,.5, 100); //Setup Speed
  mySerial.setTimeout(100); //VERY important for fast response
}

void loop()
{
  //wait for Serial moitor to become availible
  if (mySerial.available())
  {
    String value = mySerial.readStringUntil('#');
    if (value.length() == 7)
    {
      //variables  to store values of angle and magnitude
      int angle = (value.substring(0, 3)).toInt();
      int mag = (value.substring(3, 6)).toInt();

      // angle / direction detection
      if (angle < 180)
      {
        if (angle < 90)
        {
          Speed(255, map(angle, 0, 90, -255, 255), mag);
        }
        else
        {
          Speed(map(angle, 90, 180, 255, -255), 255, mag);
        }
      }
      else
      {
        if (angle < 270)
        {
          Speed(-255, map(angle, 180, 270, 255, -255), mag);
        }
        else
        {
          Speed(map(angle, 270, 360, -255, 255), -255, mag);
        }
      }
    }
  }
}

//--------------------------Motor functions-----------------------------
//-------speed functions
//function for dynamic speed adjustment
void Speed(float lSpeed, float rSpeed, float mag) {
  //checks to make sure that speed isn't too low
  if (mag > 30)
  {
    if (rSpeed > 0)
    {
      //set left wheel to drive forward
      digitalWrite(IN1, HIGH);
      digitalWrite(IN2, LOW);
    }
    else
    {
      //set left wheel to drive backward
      digitalWrite(IN1, LOW);
      digitalWrite(IN2, HIGH);
    }
    if (lSpeed > 0)
    {
      //set right wheel to drive forward
      digitalWrite(IN3, HIGH);
      digitalWrite(IN4, LOW);
    }
    else
    {
      //set right wheel to drive backward
      digitalWrite(IN3, LOW);
      digitalWrite(IN4, HIGH);
    }
    analogWrite(ENA, (abs(rSpeed) * (mag / 100)) * .5);
    analogWrite(ENB, (abs(lSpeed) * (mag / 100)) * .5);
  }
  else
  {                                        
    //if speed is below 30, just stop the bot
    //set wheels  to stop
    digitalWrite(IN1, LOW);
    digitalWrite(IN2, LOW);
    digitalWrite(IN3, LOW);
    digitalWrite(IN4, LOW);
  }
}
//-----------------------Motor functions end----------------------------
